import { MalAuthorizeRequest, MalTokenExchangeRequest, MalAuthenticationToken, MalTokenRefreshRequest } from '../../models/mal-authentication.model.cjs';
import { MalClientEndpoint } from '../../models/mal-client.model.cjs';
import '@dvcol/base-http-client';
import '@dvcol/common-utils/common/models';
import '@dvcol/common-utils/http/fetch';

/**
 * @see [authentication]{@link https://myanimelist.net/apiconfig/references/authorization#obtaining-oauth-20-access-tokens}
 */
declare const authentication: {
    /**
     * Request an authorization code.
     * @see [authorize]{@link https://myanimelist.net/apiconfig/references/authorization#step-2-client-requests-oauth-20-authentication}
     */
    authorize: MalClientEndpoint<MalAuthorizeRequest, unknown, false>;
    token: {
        /**
         * Exchange the authorization code for an access token.
         * @see [documentation]{@link https://myanimelist.net/apiconfig/references/authorization#obtaining-oauth-20-access-tokens}
         */
        exchange: MalClientEndpoint<MalTokenExchangeRequest, MalAuthenticationToken, false>;
        /**
         *
         */
        refresh: MalClientEndpoint<MalTokenRefreshRequest, MalAuthenticationToken, false>;
    };
};

export { authentication };
