import { MalClientEndpoint } from '../models/mal-client.model.cjs';
import { MalAuthorizeRequest, MalTokenExchangeRequest, MalAuthenticationToken, MalTokenRefreshRequest } from '../models/mal-authentication.model.cjs';
import '@dvcol/base-http-client';
import '@dvcol/common-utils/common/models';
import '@dvcol/common-utils/http/fetch';

/**
 * @see [documentation]{@link https://myanimelist.net/apiconfig/references/api/v2}
 */
declare const minimalMalApi: {
    authentication: {
        authorize: MalClientEndpoint<MalAuthorizeRequest, unknown, false>;
        token: {
            exchange: MalClientEndpoint<MalTokenExchangeRequest, MalAuthenticationToken, false>;
            refresh: MalClientEndpoint<MalTokenRefreshRequest, MalAuthenticationToken, false>;
        };
    };
};

export { minimalMalApi };
