// lib/models/mal-client.model.ts
import { ClientEndpoint } from "@dvcol/base-http-client";
var ApiVersion = {
  v1: "v1",
  v2: "v2"
};
var MalApiHeader = {
  MalClientId: "X-MAL-CLIENT-ID",
  MalApiVersion: "X-MAL-API-VERSION"
};
var MalAuthType = {
  /**
   * Main auth (user OAuth)
   *
   * The API client can see and modify basic profile information and users' list data, post information to MyAnimelist on behalf of users.
   * @see [documentation]{@link https://myanimelist.net/apiconfig/references/api/v2#section/Authentication}
   **/
  User: "main_auth",
  /**
   * When user login is not required, the X-MAL-CLIENT-ID request header can be used to authenticate the client by setting your API client ID.
   * @see [documentation]{@link https://myanimelist.net/apiconfig/references/api/v2#section/Authentication}
   */
  Client: "client_auth",
  /**
   * Either {@link User} or {@link Client} auth
   * @see [documentation]{@link https://myanimelist.net/apiconfig/references/api/v2#section/Authentication}
   */
  Both: "both_auth"
};
var MalClientEndpoint = class extends ClientEndpoint {
};

export {
  ApiVersion,
  MalApiHeader,
  MalAuthType,
  MalClientEndpoint
};
