"use strict";Object.defineProperty(exports, "__esModule", {value: true});

var _chunkEZBRKAE7cjs = require('./chunk-EZBRKAE7.cjs');




var _chunkX24ECJ3Pcjs = require('./chunk-X24ECJ3P.cjs');

// lib/api/endpoints/forum.endpoint.ts
var _commonutils = require('@dvcol/common-utils');
var forum = {
  /**
   * Get forum boards
   *
   * @auth client or user
   *
   * @see [forum-boards]{@link https://myanimelist.net/apiconfig/references/api/v2#operation/forum_boards_get}
   */
  boards: new (0, _chunkX24ECJ3Pcjs.MalClientEndpoint)({
    method: _commonutils.HttpMethod.GET,
    url: "/forum/boards",
    opts: {
      auth: _chunkX24ECJ3Pcjs.MalAuthType.Both,
      version: _chunkX24ECJ3Pcjs.ApiVersion.v2
    }
  }),
  topics: {
    /**
     * Get forum topics
     *
     * @auth client or user
     * @pagination true
     *
     * @see [forum-topics]{@link https://myanimelist.net/apiconfig/references/api/v2#operation/forum_topics_get}
     */
    list: new (0, _chunkX24ECJ3Pcjs.MalClientEndpoint)({
      method: _commonutils.HttpMethod.GET,
      url: "/forum/topics",
      opts: {
        auth: _chunkX24ECJ3Pcjs.MalAuthType.Both,
        version: _chunkX24ECJ3Pcjs.ApiVersion.v2,
        pagination: {
          limit: 100,
          offset: 0
        },
        parameters: {
          query: {
            board_id: false,
            subboard_id: false,
            sort: false,
            q: false,
            topic_user_name: false,
            user_name: false,
            limit: false,
            offset: false
          }
        }
      },
      validate: (param) => {
        if (param.q) _chunkEZBRKAE7cjs.MalApiValidators.minLength(param.q, { min: 3, name: "q" });
        if (param.limit) _chunkEZBRKAE7cjs.MalApiValidators.minMax(param.limit, { min: 0, max: 100, name: "limit" });
        if (param.offset) _chunkEZBRKAE7cjs.MalApiValidators.min(param.offset, { min: 0, name: "offset" });
        return true;
      }
    }),
    /**
     * Get forum topic details
     *
     * @auth client or user
     * @pagination true
     *
     * @see [forum-topic-details]{@link https://myanimelist.net/apiconfig/references/api/v2#operation/forum_topic_get
     */
    details: new (0, _chunkX24ECJ3Pcjs.MalClientEndpoint)({
      method: _commonutils.HttpMethod.GET,
      url: "/forum/topic/:id",
      opts: {
        auth: _chunkX24ECJ3Pcjs.MalAuthType.Both,
        version: _chunkX24ECJ3Pcjs.ApiVersion.v2,
        pagination: {
          limit: 100,
          offset: 0
        },
        parameters: {
          path: {
            id: true
          },
          query: {
            limit: false,
            offset: false
          }
        }
      },
      validate: (param) => {
        if (param.limit) _chunkEZBRKAE7cjs.MalApiValidators.minMax(param.limit, { min: 0, max: 100, name: "limit" });
        if (param.offset) _chunkEZBRKAE7cjs.MalApiValidators.min(param.offset, { min: 0, name: "offset" });
        return true;
      }
    })
  }
};



exports.forum = forum;
