"use strict";Object.defineProperty(exports, "__esModule", {value: true});

var _chunkGXLUSQ7Kcjs = require('./chunk-GXLUSQ7K.cjs');



var _chunkX24ECJ3Pcjs = require('./chunk-X24ECJ3P.cjs');

// lib/api/endpoints/authentication.endpoint.ts
var _commonutils = require('@dvcol/common-utils');
var authentication = {
  /**
   * Request an authorization code.
   * @see [authorize]{@link https://myanimelist.net/apiconfig/references/authorization#step-2-client-requests-oauth-20-authentication}
   */
  authorize: new (0, _chunkX24ECJ3Pcjs.MalClientEndpoint)({
    method: _commonutils.HttpMethod.GET,
    url: "/oauth2/authorize",
    seed: {
      response_type: "code"
    },
    init: {
      redirect: "manual",
      credentials: "omit"
    },
    opts: {
      version: _chunkX24ECJ3Pcjs.ApiVersion.v1,
      endpoint: _chunkGXLUSQ7Kcjs.Config.Website,
      cache: false,
      parameters: {
        query: {
          client_id: true,
          code_challenge: true,
          code_challenge_method: false,
          state: false,
          redirect_uri: false,
          response_type: true
        }
      }
    }
  }),
  token: {
    /**
     * Exchange the authorization code for an access token.
     * @see [documentation]{@link https://myanimelist.net/apiconfig/references/authorization#obtaining-oauth-20-access-tokens}
     */
    exchange: new (0, _chunkX24ECJ3Pcjs.MalClientEndpoint)({
      method: _commonutils.HttpMethod.POST,
      url: "/oauth2/token",
      seed: {
        grant_type: "authorization_code"
      },
      opts: {
        version: _chunkX24ECJ3Pcjs.ApiVersion.v1,
        endpoint: _chunkGXLUSQ7Kcjs.Config.Website,
        cache: false
      },
      body: {
        client_id: true,
        client_secret: true,
        code: true,
        code_verifier: true,
        redirect_uri: false,
        grant_type: true
      }
    }),
    /**
     *
     */
    refresh: new (0, _chunkX24ECJ3Pcjs.MalClientEndpoint)({
      method: _commonutils.HttpMethod.POST,
      url: "/oauth2/token",
      seed: {
        grant_type: "refresh_token"
      },
      opts: {
        version: _chunkX24ECJ3Pcjs.ApiVersion.v1,
        endpoint: _chunkGXLUSQ7Kcjs.Config.Website,
        cache: false
      },
      body: {
        client_id: true,
        client_secret: true,
        refresh_token: true,
        grant_type: false
      }
    })
  }
};



exports.authentication = authentication;
