"use strict";Object.defineProperty(exports, "__esModule", {value: true});

var _chunkLDFQFITGcjs = require('./chunk-LDFQFITG.cjs');


var _chunkEZBRKAE7cjs = require('./chunk-EZBRKAE7.cjs');




var _chunkX24ECJ3Pcjs = require('./chunk-X24ECJ3P.cjs');

// lib/api/endpoints/manga.endpoint.ts
var _commonutils = require('@dvcol/common-utils');
var manga = {
  /**
   * Get manga list
   *
   * @auth client or user
   * @pagination true
   * @nsfw true
   *
   * @see [manga-list]{@link https://myanimelist.net/apiconfig/references/api/v2#operation/manga_get}
   */
  list: new (0, _chunkX24ECJ3Pcjs.MalClientEndpoint)({
    method: _commonutils.HttpMethod.GET,
    url: "/manga",
    opts: {
      nsfw: true,
      auth: _chunkX24ECJ3Pcjs.MalAuthType.Both,
      version: _chunkX24ECJ3Pcjs.ApiVersion.v2,
      pagination: {
        limit: 500,
        offset: 0
      },
      parameters: {
        query: {
          q: true,
          fields: false,
          nsfw: false,
          limit: false,
          offset: false
        }
      }
    },
    transform: (param) => {
      if (param.fields) return { ...param, fields: _chunkLDFQFITGcjs.MalApiTransforms.fields(param.fields) };
      return param;
    },
    validate: (param) => {
      if (param.q) _chunkEZBRKAE7cjs.MalApiValidators.minLength(param.q, { min: 3, name: "q" });
      if (param.limit) _chunkEZBRKAE7cjs.MalApiValidators.minMax(param.limit, { min: 0, max: 500, name: "limit" });
      if (param.offset) _chunkEZBRKAE7cjs.MalApiValidators.min(param.offset, { min: 0, name: "offset" });
      return true;
    }
  }),
  /**
   * Get manga details.
   *
   * @auth client or user
   *
   * @see [manga-details]{@link https://myanimelist.net/apiconfig/references/api/v2#operation/manga_manga_id_get}
   */
  details: new (0, _chunkX24ECJ3Pcjs.MalClientEndpoint)({
    method: _commonutils.HttpMethod.GET,
    url: "/manga/:id",
    opts: {
      auth: _chunkX24ECJ3Pcjs.MalAuthType.Both,
      version: _chunkX24ECJ3Pcjs.ApiVersion.v2,
      parameters: {
        path: {
          id: true
        },
        query: {
          fields: false
        }
      }
    },
    transform: (param) => {
      if (param.fields) return { ...param, fields: _chunkLDFQFITGcjs.MalApiTransforms.fields(param.fields) };
      return param;
    }
  }),
  /**
   * Get manga rankings.
   *
   * The returned manga contains the ranking field.
   *
   * @auth client or user
   * @pagination true
   * @nsfw true
   *
   * @see [manga-rankings]{@link https://myanimelist.net/apiconfig/references/api/v2#operation/manga_ranking_get}
   */
  ranking: new (0, _chunkX24ECJ3Pcjs.MalClientEndpoint)({
    method: _commonutils.HttpMethod.GET,
    url: "/manga/ranking",
    opts: {
      nsfw: true,
      auth: _chunkX24ECJ3Pcjs.MalAuthType.Both,
      version: _chunkX24ECJ3Pcjs.ApiVersion.v2,
      pagination: {
        limit: 500,
        offset: 0
      },
      parameters: {
        query: {
          ranking_type: false,
          fields: false,
          nsfw: false,
          limit: false,
          offset: false
        }
      }
    }
  })
};



exports.manga = manga;
