// lib/api/transforms/mal-api.transforms.ts
var MalApiTransforms = {
  array: {
    /** Join array elements with separator (defaults to comma ',') */
    toString: (arrayOrString, separator = ",") => {
      if (arrayOrString && Array.isArray(arrayOrString)) return arrayOrString.join(separator);
      return arrayOrString;
    }
  },
  fields: (fields) => {
    if (typeof fields === "string") return fields;
    if (Array.isArray(fields)) return fields.join(",");
    return Object.entries(fields).map(([key, value]) => {
      if (!value?.length) return;
      if (Array.isArray(value)) return `${key}{${value.join(",")}}`;
      return value;
    }).join(",");
  }
};

export {
  MalApiTransforms
};
