"use strict";Object.defineProperty(exports, "__esModule", {value: true});

var _chunkLDFQFITGcjs = require('./chunk-LDFQFITG.cjs');


var _chunkEZBRKAE7cjs = require('./chunk-EZBRKAE7.cjs');




var _chunkX24ECJ3Pcjs = require('./chunk-X24ECJ3P.cjs');

// lib/api/endpoints/anime.endpoint.ts
var _commonutils = require('@dvcol/common-utils');
var anime = {
  /**
   * Get anime list.
   *
   * @pagination true
   * @nsfw true
   * @auth client or user
   *
   * @see [anime-list]{@link https://myanimelist.net/apiconfig/references/api/v2#operation/anime_get}
   */
  list: new (0, _chunkX24ECJ3Pcjs.MalClientEndpoint)({
    method: _commonutils.HttpMethod.GET,
    url: "/anime",
    opts: {
      nsfw: true,
      auth: _chunkX24ECJ3Pcjs.MalAuthType.Both,
      version: _chunkX24ECJ3Pcjs.ApiVersion.v2,
      pagination: {
        limit: 500,
        offset: 0
      },
      parameters: {
        query: {
          q: true,
          fields: false,
          nsfw: false,
          limit: false,
          offset: false
        }
      }
    },
    transform: (param) => {
      if (param.fields) return { ...param, fields: _chunkLDFQFITGcjs.MalApiTransforms.fields(param.fields) };
      return param;
    },
    validate: (param) => {
      if (param.q) _chunkEZBRKAE7cjs.MalApiValidators.minLength(param.q, { min: 3, name: "q" });
      if (param.limit) _chunkEZBRKAE7cjs.MalApiValidators.minMax(param.limit, { min: 0, max: 500, name: "limit" });
      if (param.offset) _chunkEZBRKAE7cjs.MalApiValidators.min(param.offset, { min: 0, name: "offset" });
      return true;
    }
  }),
  /**
   * Get anime details.
   *
   * @auth client or user
   *
   * @see [anime-details]{@link https://myanimelist.net/apiconfig/references/api/v2#operation/anime_anime_id_get}
   */
  details: new (0, _chunkX24ECJ3Pcjs.MalClientEndpoint)({
    method: _commonutils.HttpMethod.GET,
    url: "/anime/:id",
    opts: {
      auth: _chunkX24ECJ3Pcjs.MalAuthType.Both,
      version: _chunkX24ECJ3Pcjs.ApiVersion.v2,
      parameters: {
        path: {
          id: true
        },
        query: {
          fields: false
        }
      }
    },
    transform: (param) => {
      if (param.fields) return { ...param, fields: _chunkLDFQFITGcjs.MalApiTransforms.fields(param.fields) };
      return param;
    }
  }),
  /**
   * Get anime rankings.
   *
   * @pagination true
   * @auth client or user
   * @nsfw true
   *
   * @see [anime-rankings]{@link https://myanimelist.net/apiconfig/references/api/v2#operation/anime_ranking_get}
   */
  ranking: new (0, _chunkX24ECJ3Pcjs.MalClientEndpoint)({
    method: _commonutils.HttpMethod.GET,
    url: "/anime/ranking",
    opts: {
      nsfw: true,
      auth: _chunkX24ECJ3Pcjs.MalAuthType.Both,
      version: _chunkX24ECJ3Pcjs.ApiVersion.v2,
      pagination: {
        limit: 500,
        offset: 0
      },
      parameters: {
        query: {
          ranking_type: false,
          fields: false,
          nsfw: false,
          limit: false,
          offset: false
        }
      }
    },
    transform: (param) => {
      if (param.fields) return { ...param, fields: _chunkLDFQFITGcjs.MalApiTransforms.fields(param.fields) };
      return param;
    },
    validate: (param) => {
      if (param.limit) _chunkEZBRKAE7cjs.MalApiValidators.minMax(param.limit, { min: 0, max: 500, name: "limit" });
      if (param.offset) _chunkEZBRKAE7cjs.MalApiValidators.min(param.offset, { min: 0, name: "offset" });
      return true;
    }
  }),
  /**
   * Get list of anime airing for season.
   *
   * @auth client or user
   * @pagination true
   * @nsfw true
   *
   * @see [anime-seasonal]{@link https://myanimelist.net/apiconfig/references/api/v2#operation/anime_season_year_season_get}
   */
  seasonal: new (0, _chunkX24ECJ3Pcjs.MalClientEndpoint)({
    method: _commonutils.HttpMethod.GET,
    url: "/anime/season/:year/:season",
    opts: {
      nsfw: true,
      auth: _chunkX24ECJ3Pcjs.MalAuthType.Both,
      version: _chunkX24ECJ3Pcjs.ApiVersion.v2,
      pagination: {
        limit: 500,
        offset: 0
      },
      parameters: {
        path: {
          year: true,
          season: true
        },
        query: {
          sort: false,
          fields: false,
          nsfw: false,
          limit: false,
          offset: false
        }
      }
    },
    transform: (param) => {
      if (param.fields) return { ...param, fields: _chunkLDFQFITGcjs.MalApiTransforms.fields(param.fields) };
      return param;
    },
    validate: (param) => {
      if (param.limit) _chunkEZBRKAE7cjs.MalApiValidators.minMax(param.limit, { min: 0, max: 500, name: "limit" });
      if (param.offset) _chunkEZBRKAE7cjs.MalApiValidators.min(param.offset, { min: 0, name: "offset" });
      return true;
    }
  }),
  /**
   * Get list of suggested anime for a specific anime.
   *
   * Returns suggested anime for the authorized user.
   *
   * If the user is new comer, this endpoint returns an empty list.
   *
   * @auth user
   * @pagination true
   * @nsfw true
   *
   *@see [anime-suggestions]{@link https://myanimelist.net/apiconfig/references/api/v2#operation/anime_suggestions_get}
   */
  suggestions: new (0, _chunkX24ECJ3Pcjs.MalClientEndpoint)({
    method: _commonutils.HttpMethod.GET,
    url: "/anime/suggestions",
    opts: {
      nsfw: true,
      auth: _chunkX24ECJ3Pcjs.MalAuthType.User,
      version: _chunkX24ECJ3Pcjs.ApiVersion.v2,
      pagination: {
        limit: 500,
        offset: 0
      },
      parameters: {
        query: {
          fields: false,
          nsfw: false,
          limit: false,
          offset: false
        }
      }
    },
    transform: (param) => {
      if (param.fields) return { ...param, fields: _chunkLDFQFITGcjs.MalApiTransforms.fields(param.fields) };
      return param;
    },
    validate: (param) => {
      if (param.limit) _chunkEZBRKAE7cjs.MalApiValidators.minMax(param.limit, { min: 0, max: 500, name: "limit" });
      if (param.offset) _chunkEZBRKAE7cjs.MalApiValidators.min(param.offset, { min: 0, name: "offset" });
      return true;
    }
  })
};



exports.anime = anime;
