"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _nullishCoalesce(lhs, rhsFn) { if (lhs != null) { return lhs; } else { return rhsFn(); } } function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) { const op = ops[i]; const fn = ops[i + 1]; i += 2; if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) { return undefined; } if (op === 'access' || op === 'optionalAccess') { lastAccessLHS = value; value = fn(value); } else if (op === 'call' || op === 'optionalCall') { value = fn((...args) => value.call(lastAccessLHS, ...args)); lastAccessLHS = undefined; } } return value; }

var _chunkCG25BOD6cjs = require('./chunk-CG25BOD6.cjs');




var _chunkVXCA4AXPcjs = require('./chunk-VXCA4AXP.cjs');



var _chunkX24ECJ3Pcjs = require('./chunk-X24ECJ3P.cjs');

// lib/clients/base-mal-client.ts
var _basehttpclient = require('@dvcol/base-http-client');
var _client = require('@dvcol/base-http-client/utils/client');
var _http = require('@dvcol/base-http-client/utils/http');
var _commonutils = require('@dvcol/common-utils');
var parsePagingLinks = (link) => {
  const params = new URLSearchParams(_nullishCoalesce(link.split("?")[1], () => ( link)));
  return {
    offset: Number(params.get("offset")),
    limit: Number(params.get("limit"))
  };
};
var isPagedData = (data) => "paging" in data;
var parseResponse = (response) => {
  if (!isPagedData(response)) return response;
  const result = {
    data: response.data,
    pagination: {}
  };
  if (response.paging.previous) result.pagination.previous = { ...parsePagingLinks(response.paging.previous), link: response.paging.previous };
  if (response.paging.next) result.pagination.next = { ...parsePagingLinks(response.paging.next), link: response.paging.next };
  return result;
};
var patchMalResponse = (response) => _client.patchResponse.call(void 0, response, parseResponse);
var BaseMalClient = class extends _basehttpclient.BaseClient {
  /**
   * Creates an instance of BaseMalClient.
   * @param options - The options for the client.
   * @param authentication - The authentication for the client.
   * @param api - The API endpoints for the client.
   */
  constructor(options, authentication = {}, api = {}) {
    const _authentication = authentication instanceof _chunkCG25BOD6cjs.MalClientAuthentication ? authentication : new (0, _chunkCG25BOD6cjs.MalClientAuthentication)(authentication);
    super(options, _authentication, api);
  }
  /**
   * Parses the template to construct the headers for a Mal API request.
   *
   * @protected
   *
   * @template T - The type of the parameters.
   *
   * @param {MalApiTemplate<T>} template - The template for the API endpoint.
   *
   * @returns {HeadersInit} The parsed request headers.
   *
   * @throws {Error} Throws an error if OAuth is required and the access token is missing.
   */
  _parseHeaders(template) {
    const headers = {
      [_http.BaseApiHeaders.UserAgent]: this.settings.useragent,
      [_http.BaseApiHeaders.ContentType]: [_commonutils.HttpMethod.POST, _commonutils.HttpMethod.PUT, _commonutils.HttpMethod.PATCH].map(String).includes(template.method) ? _http.BaseHeaderContentType.FormUrlEncoded : _http.BaseHeaderContentType.Json,
      [_chunkX24ECJ3Pcjs.MalApiHeader.MalClientId]: this.settings.client_id,
      [_chunkX24ECJ3Pcjs.MalApiHeader.MalApiVersion]: _optionalChain([template, 'access', _ => _.opts, 'optionalAccess', _2 => _2.version])
    };
    if (_optionalChain([template, 'access', _3 => _3.opts, 'optionalAccess', _4 => _4.auth]) === _chunkX24ECJ3Pcjs.MalAuthType.Client && !this.settings.client_id) {
      throw new (0, _chunkVXCA4AXPcjs.MalInvalidParameterError)("OAuth required: client_id is missing");
    }
    if (_optionalChain([template, 'access', _5 => _5.opts, 'optionalAccess', _6 => _6.auth]) === _chunkX24ECJ3Pcjs.MalAuthType.User) {
      if (!this.auth.access_token) throw new (0, _chunkVXCA4AXPcjs.MalInvalidParameterError)("OAuth required: access_token is missing");
      else if (this.auth.isExpired()) throw new (0, _chunkVXCA4AXPcjs.MalExpiredTokenError)("OAuth required: access_token has expired");
    }
    if (_optionalChain([template, 'access', _7 => _7.opts, 'optionalAccess', _8 => _8.auth]) && this.auth.access_token) headers[_http.BaseApiHeaders.Authorization] = `Bearer ${this.auth.access_token}`;
    return headers;
  }
  /**
   * Parses the parameters and constructs the URL for a Mal API request.
   *
   * @protected
   *
   * @template T - The type of the parameters.
   *
   * @param template - The template for the API endpoint.
   * @param {T} params - The parameters for the API call.
   *
   * @returns {string} The URL for the Mal API request.
   *
   * @throws {Error} Throws an error if mandatory parameters are missing or if a filter is not supported.
   */
  _parseUrl(template, params) {
    const versionedTemplate = _client.injectUrlPrefix.call(void 0, `/${template.opts.version}`, template);
    if (template.opts.endpoint) return _client.parseUrl.call(void 0, versionedTemplate, params, template.opts.endpoint);
    const _template = _client.injectCorsProxyPrefix.call(void 0, versionedTemplate, this.settings);
    return _client.parseUrl.call(void 0, _template, params, this.settings.endpoint);
  }
  /**
   * Parses body from a template and stringifies a {@link BodyInit}
   *
   * @protected
   *
   * @template T - The type of the parameters.
   *
   * @param template - The expected body structure.
   * @param {T} params - The actual parameters.
   *
   * @returns {BodyInit} The parsed request body.
   */
  // eslint-disable-next-line class-methods-use-this -- implemented from abstract class
  _parseBody(template, params) {
    return _client.parseBodyUrlEncoded.call(void 0, template, params);
  }
  /**
   * Parses the response from the API before returning from the call.
   * @param response - The response from the API.
   *
   * @returns {MalApiResponse} The parsed response.
   * @protected
   */
  // eslint-disable-next-line class-methods-use-this -- implemented from abstract class
  _parseResponse(response) {
    if (response.status === 401 && _optionalChain([response, 'access', _9 => _9.headers, 'access', _10 => _10.get, 'call', _11 => _11(_http.BaseApiHeaders.Authenticate), 'optionalAccess', _12 => _12.includes, 'call', _13 => _13("token expired")])) {
      throw new (0, _chunkVXCA4AXPcjs.MalExpiredTokenError)("OAuth required: access_token has expired", response);
    }
    if (response.status === 429) throw new (0, _chunkVXCA4AXPcjs.MalRateLimitError)(response.statusText, response);
    if (!response.ok || response.status >= 400) throw response;
    const parsed = patchMalResponse(response);
    const _clone = parsed.clone;
    parsed.clone = () => patchMalResponse(_clone.bind(parsed)());
    return parsed;
  }
};




exports.parseResponse = parseResponse; exports.BaseMalClient = BaseMalClient;
